package org.springblade.estate.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.estate.entity.Banners;
import org.springblade.estate.vo.BannersVO;
import org.springblade.estate.wrapper.BannersWrapper;
import org.springblade.estate.service.IBannersService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-18
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/banners")

public class BannersClient implements IBannersClient {

    private final IBannersService bannersService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public BannersVO detail(@SpringQueryMap Banners banners) {
        Banners detail = bannersService.getOne(Condition.getQueryWrapper(banners));
        return BannersWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<BannersVO> list(@SpringQueryMap Banners banners) {
        return BannersWrapper.build().listVO(bannersService.list(Condition.getQueryWrapper(banners)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Banners banners) {
        return bannersService.save(banners);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Banners banners) {
        return bannersService.updateById(banners);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Banners banners) {
        return bannersService.saveOrUpdate(banners);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return bannersService.deleteLogic(Func.toLongList(ids));
        }


}
